<?php
/**
 * @version             $Id: pedigree.php 3.0 2015-04-08 HB $
 * @package             Joomla
 * @copyright   Copyright (C) 2011-2015 Setter-anglais.fr/Tangor.net. All rights reserved.
 * @license             GNU/GPL, see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

jimport('joomla.event.plugin');
jimport('joomla.document.document');

require_once (JPATH_SITE . '/components/com_content/helpers/route.php');

class plgContentPedigree extends JPlugin {
	
	protected $autoloadLanguage = true;
	
	function plgContentPedigree( &$subject, $params )
	{
		parent::__construct( $subject, $params );

		$this->Host = $this->params->get( 'pedigree_host', '' );
		$this->Langue = $this->params->get( 'pedigree_language', 'FR' );
		$this->PZ = $this->params->get( 'pedigree_generations', '3' );
		$this->CssStyle = $this->params->get( 'pedigree_css', '' );
	}

	public function onContentPrepare($context, &$row, &$params, $limitstart)

	{
		$bTrouve = false;

		if (is_object($row)) {
			$text = $row->text;
		} else {
			$text = $row;
		}

		$this->MsgErr = '';
		$regex = '#{pedigree([^}]*)}#is';

		$plugin_enabled = JPluginHelper::isEnabled('content', 'pedigree');
		if($plugin_enabled == "0") {
			$text = preg_replace($regex, '', $text);
		} else {
			if (preg_match_all($regex, $text, $matches, PREG_SET_ORDER) > 0) {
      
				foreach ($matches as $match) {
   					$params0 = & JUtility::parseAttributes($match[1]);
					$id = $params0['id'];
					if (! ($id > 0) ) {
						$this->MsgErr = "Error parameter pedigree 'id'.";
					} else {
						$text = preg_replace($regex, $this->Pedigree($id), $text, 1);
						$bTrouve = true;
					}
					unset($params0);
				}
			}
		}

		// Print error messages
		if($this->MsgErr) {
				$this->MsgErr = str_replace('\\n', "\n", $this->MsgErr);
				$text = "<div style='border:2px solid black; padding: 10px; background-color: white; font-weight: bold; color: red;'>Pedigree error on this page:<br /><br />\n\n".$this->MsgErr."</div>" . $text;
		}
		
		// Update headers
		if ($bTrouve) {
			$this->AddHeader('style');

			if (is_object($row)) {
				$row->text = $text;
			} else {
				$row = $text;
			}
		}
	}

	private function Pedigree($id)
	{
		$url = $this->Host . "/genealogie/arbre.php?id=$id&fn=pedigree&EMBED=UTF-8&HOST={$this->Host}&LANGUE={$this->Langue}&PZ={$this->PZ}";
		$text = file_get_contents($url);
		return $text;
	}

	private function AddHeader($headertype)
	{
		$document 	= &JFactory::getDocument();
    	if($headertype=='style' && !isset($headers['style'])) {
    		$headers['style'] = 1;
    		$document->addStyleDeclaration( "/* Pedigree CSS */\n"
				. str_replace(array('<br />', '\[', '\]', '&nbsp;'), array("\n", '{', '}', ' '), $this->CssStyle."\n"));
    	}
	}
	
}

?>